'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initializeLogger = exports.LOGGER = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _winston = require('winston');

var _winston2 = _interopRequireDefault(_winston);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Logger = function () {
  function Logger(config) {
    _classCallCheck(this, Logger);

    if (config.logLevel === undefined) {
      config.logLevel = 'silly';
    }

    this.logger = new _winston2.default.Logger({
      transports: [new _winston2.default.transports.Console({ level: config.logLevel }), new _winston2.default.transports.File({ filename: 'application.log', level: 'silly' })]
    });
    this.initialized = true;
  }

  // Log level: 0


  _createClass(Logger, [{
    key: 'error',
    value: function error() {
      if (this.initialized !== true) {
        throw new Error("Attempted to log something before the LOGGER had a chance to be initialized.");
      }
      this.logger.error.apply(this, arguments);
    }

    // Log level: 1

  }, {
    key: 'warn',
    value: function warn() {
      if (this.initialized !== true) {
        throw new Error("Attempted to log something before the LOGGER had a chance to be initialized.");
      }
      this.logger.warn.apply(this, arguments);
    }

    // Log level: 2

  }, {
    key: 'info',
    value: function info() {
      if (this.initialized !== true) {
        throw new Error("Attempted to log something before the LOGGER had a chance to be initialized.");
      }
      this.logger.info.apply(this, arguments);
    }

    // Log level: 3

  }, {
    key: 'verbose',
    value: function verbose() {
      if (this.initialized !== true) {
        throw new Error("Attempted to log something before the LOGGER had a chance to be initialized.");
      }
      this.logger.verbose.apply(this, arguments);
    }

    // Log level: 4

  }, {
    key: 'debug',
    value: function debug() {
      if (this.initialized !== true) {
        throw new Error("Attempted to log something before the LOGGER had a chance to be initialized.");
      }
      this.logger.debug.apply(this, arguments);
    }

    // Log level: 5

  }, {
    key: 'silly',
    value: function silly() {
      if (this.initialized !== true) {
        throw new Error("Attempted to log something before the LOGGER had a chance to be initialized.");
      }
      this.logger.silly.apply(this, arguments);
    }
  }]);

  return Logger;
}();

// Export a reference to the logger as LOGGER


var LOGGER = exports.LOGGER = "Logger has not been initialized yet!";
var initializeLogger = exports.initializeLogger = function initializeLogger(config) {
  exports.LOGGER = LOGGER = new Logger(config);
};